// BUSINESS COMPONENT

//Provided Interface
// Connected to Distribution Component
public class HealthWatcherFacadeInit {

	public void updateHealthUnit(HealthUnit unit)throws RepositoryException, ObjectNotFoundException,TransactionException {

	public void updateComplaint(Complaint complaint)throws TransactionException, RepositoryException,ObjectNotFoundException, ObjectNotValidException {

	public IteratorDsk searchSpecialitiesByHealthUnit(int code) throws ObjectNotFoundException, RepositoryException,TransactionException {

	public Complaint searchComplaint(int code) throws RepositoryException,ObjectNotFoundException, TransactionException {

	public DiseaseType searchDiseaseType(int code) throws RepositoryException,ObjectNotFoundException, TransactionException {

	public IteratorDsk searchHealthUnitsBySpeciality(int code) throws ObjectNotFoundException, RepositoryException,TransactionException {

	public IteratorDsk getSpecialityList() throws RepositoryException,ObjectNotFoundException, TransactionException {

	public IteratorDsk getDiseaseTypeList() throws RepositoryException,ObjectNotFoundException, TransactionException {

	public HealthUnit searchHealthUnit(int healthUnitCode) throws ObjectNotFoundException,RepositoryException {

	public IteratorDsk getHealthUnitList() throws RepositoryException,ObjectNotFoundException, TransactionException {

	public IteratorDsk getPartialHealthUnitList() throws RepositoryException,ObjectNotFoundException, TransactionException {

	public void insert(Employee employee)throws ObjectAlreadyInsertedException, ObjectNotValidException,TransactionException {

	public int insertComplaint(Complaint complaint) throws RepositoryException,ObjectAlreadyInsertedException, ObjectNotValidException,TransactionException {

	public Employee searchEmployee(String login) throws ObjectNotFoundException,TransactionException{

	public IteratorDsk getComplaintList() throws ObjectNotFoundException,TransactionException {

	public void update(Employee employee) throws TransactionException, RepositoryException,ObjectNotFoundException, ObjectNotValidException{
}

//Required Interface
// Connected to Persistence Component
public interface initPersistenceMechanism {
	public static synchronized PersistenceMechanism getInstance() throws PersistenceMechanismException
    public void connect() throws PersistenceMechanismException;
    public void disconnect() throws PersistenceMechanismException;
	// These methods represent the repository contructors calls inside HealthWatcherFacade
	public void initComplaintRepository();
	public void initHealthUnitRepository();
	public void initSpecialityRepository();
	public void initDiseaseType();
	public void initEmployeeRepository();
}

//Required Interface
// Connected to Persistence Component
public interface transactionControlMechanism {
    public void rollbackTransaction() throws TransactionException;
    public void commitTransaction() throws TransactionException;
    public void beginTransaction() throws TransactionException;
}

// Required Interface
// Connected to Persistence Component
public interface IComplaintRepository {

    public Complaint search(int complaint) throws RepositoryException, ObjectNotFoundException;

    public void update(Complaint complaint) throws RepositoryException, ObjectNotFoundException, ObjectNotValidException;

    public int insert(Complaint complaint) throws RepositoryException, ObjectAlreadyInsertedException, ObjectNotValidException;

    public boolean exists(int code) throws RepositoryException;

    public void remove(int codigo) throws RepositoryException, ObjectNotFoundException;
    
    public IteratorDsk getComplaintList() throws SearchEntryException, ObjectNotFoundException;
}

// Required Interface
// Connected to Persistence Component
public interface IDiseaseRepository {

    public DiseaseType search(int code) throws RepositoryException, ObjectNotFoundException;

    public void update(DiseaseType td) throws RepositoryException, ObjectNotFoundException, ObjectNotValidException;

    public void insert(DiseaseType td)throws RepositoryException, ObjectAlreadyInsertedException, ObjectNotValidException;

    public boolean exists(int code) throws RepositoryException;
    
    public IteratorDsk getDiseaseTypeList() throws RepositoryException, ObjectNotFoundException;
}

// Required Interface
// Connected to Persistence Component
public interface ISymptomRepository {

    public void insert(Symptom s) throws RepositoryException, ObjectAlreadyInsertedException,ObjectNotValidException;

    public void update(Symptom s) throws RepositoryException, ObjectNotFoundException, ObjectNotValidException;

    public boolean exists(int code) throws RepositoryException;

    public Symptom search(int code) throws RepositoryException, ObjectNotFoundException;

    public void remove(int code) throws RepositoryException, ObjectNotFoundException;
}

// Required Interface
// Connected to Persistence Component
public interface IEmployeeRepository {

    public Employee search(String login) throws ObjectNotFoundException;

    public void update(Employee employee) throws ObjectNotFoundException, ObjectNotValidException;

    public void insert(Employee employee) throws InsertEntryException;

    public boolean exists(String login);

    public void remove(String login) throws ObjectNotFoundException;
}

// Required Interface
// Connected to Persistence Component
public interface IHealthUnitRepository {

    public void update(HealthUnit us) throws RepositoryException, ObjectNotFoundException,ObjectNotValidException;
    
    public boolean exists(int num) throws RepositoryException;
    
    public IteratorDsk getHealthUnitList() throws RepositoryException, ObjectNotFoundException;
    
    public IteratorDsk getPartialHealthUnitList() throws RepositoryException, ObjectNotFoundException;
    
    public IteratorDsk getHealthUnitListBySpeciality(int codEspecialidade) throws RepositoryException, ObjectNotFoundException;
    
    public void insert(HealthUnit us)  throws RepositoryException, ObjectAlreadyInsertedException,ObjectNotValidException;
    
    public HealthUnit search(int code) throws RepositoryException, ObjectNotFoundException;
    
    public void remove(int code) throws RepositoryException, ObjectNotFoundException;
}

// Required Interface
// Connected to Persistence Component
public interface ISpecialityRepository {

    public void update(MedicalSpeciality esp) throws RepositoryException, ObjectNotFoundException,ObjectNotValidException;
    
    public boolean exists(int num) throws RepositoryException;
    
    public IteratorDsk getSpecialityList() throws RepositoryException, ObjectNotFoundException;
    
    public void insert(MedicalSpeciality esp) throws RepositoryException, ObjectAlreadyInsertedException,ObjectNotValidException;
    
    public MedicalSpeciality search(int codigo) throws RepositoryException, ObjectNotFoundException;
    
    public void remove(int codigo) throws RepositoryException, ObjectNotFoundException;
}

// Required Interface
// Connected to Business Component
public class ConcurrencyManager {
	
    public synchronized void beginExecution(Object key)

	public synchronized void endExecution(Object key)
    
}